#line 1 "ext/ohcount_native/ragel_parsers/xaml.rl"
/************************* Required for every parser *************************/
#ifndef RAGEL_XAML_PARSER
#define RAGEL_XAML_PARSER

#include "ragel_parser_macros.h"

// the name of the language
const char *XAML_LANG = "xaml";

// the languages entities
const char *xaml_entities[] = {
  "space", "comment", "doctype",
  "tag", "entity", "any"
};

// constants associated with the entities
enum {
  XAML_SPACE = 0, XAML_COMMENT, XAML_DOCTYPE,
  XAML_TAG, XAML_ENTITY, XAML_ANY
};

/*****************************************************************************/


#line 27 "ext/ohcount_native/ragel_parsers/xaml.h"
static const char _xaml_actions[] = {
	0, 1, 0, 1, 1, 1, 5, 1, 
	6, 1, 8, 1, 9, 1, 10, 1, 
	11, 1, 13, 1, 14, 1, 17, 1, 
	18, 1, 19, 1, 20, 1, 22, 1, 
	23, 1, 24, 1, 25, 2, 0, 14, 
	2, 3, 2, 2, 4, 2, 2, 6, 
	15, 2, 7, 16, 2, 9, 21, 2, 
	12, 7, 2, 12, 9, 3, 3, 2, 
	1, 3, 4, 2, 0
};

static const char _xaml_cond_offsets[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 1, 2, 3, 4, 4, 
	4, 4, 4, 4, 4, 4, 5, 6, 
	7, 8, 8, 8, 8, 8, 8, 9, 
	9, 9, 9, 9
};

static const char _xaml_cond_lengths[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 1, 1, 1, 1, 0, 0, 
	0, 0, 0, 0, 0, 1, 1, 1, 
	1, 0, 0, 0, 0, 0, 1, 0, 
	0, 0, 0, 0
};

static const short _xaml_cond_keys[] = {
	13, 13, 13, 13, 13, 13, 13, 13, 
	13, 13, 13, 13, 13, 13, 13, 13, 
	13, 13, 0
};

static const char _xaml_cond_spaces[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0
};

static const unsigned char _xaml_key_offsets[] = {
	0, 0, 1, 2, 3, 4, 6, 10, 
	14, 16, 17, 28, 39, 50, 62, 63, 
	64, 65, 66, 67, 68, 69, 80, 91, 
	102, 114, 115, 116, 120, 123, 124, 137, 
	139, 143, 147, 148
};

static const short _xaml_trans_keys[] = {
	45, 45, 45, 45, 45, 62, 10, 34, 
	12, 13, 10, 39, 12, 13, 45, 91, 
	45, 9, 10, 12, 32, 45, 269, 525, 
	-128, 11, 14, 127, 9, 10, 12, 32, 
	45, 269, 525, -128, 11, 14, 127, 9, 
	10, 12, 32, 45, 269, 525, -128, 11, 
	14, 127, 9, 10, 12, 32, 45, 62, 
	269, 525, -128, 11, 14, 127, 10, 67, 
	68, 65, 84, 65, 91, 9, 10, 12, 
	32, 93, 269, 525, -128, 11, 14, 127, 
	9, 10, 12, 32, 93, 269, 525, -128, 
	11, 14, 127, 9, 10, 12, 32, 93, 
	269, 525, -128, 11, 14, 127, 9, 10, 
	12, 32, 62, 93, 269, 525, -128, 11, 
	14, 127, 10, 10, 32, 60, 9, 13, 
	32, 9, 13, 33, 9, 10, 12, 32, 
	34, 39, 60, 269, 525, -128, 8, 14, 
	127, 9, 32, 10, 34, 12, 13, 10, 
	39, 12, 13, 33, 10, 0
};

static const char _xaml_single_lengths[] = {
	0, 1, 1, 1, 1, 2, 2, 2, 
	2, 1, 7, 7, 7, 8, 1, 1, 
	1, 1, 1, 1, 1, 7, 7, 7, 
	8, 1, 1, 2, 1, 1, 9, 2, 
	2, 2, 1, 1
};

static const char _xaml_range_lengths[] = {
	0, 0, 0, 0, 0, 0, 1, 1, 
	0, 0, 2, 2, 2, 2, 0, 0, 
	0, 0, 0, 0, 0, 2, 2, 2, 
	2, 0, 0, 1, 1, 0, 2, 0, 
	1, 1, 0, 0
};

static const unsigned char _xaml_index_offsets[] = {
	0, 0, 2, 4, 6, 8, 11, 15, 
	19, 22, 24, 34, 44, 54, 65, 67, 
	69, 71, 73, 75, 77, 79, 89, 99, 
	109, 120, 122, 124, 128, 131, 133, 145, 
	148, 152, 156, 158
};

static const char _xaml_indicies[] = {
	1, 0, 2, 0, 3, 2, 4, 2, 
	4, 5, 2, 6, 8, 6, 7, 6, 
	8, 6, 9, 10, 11, 6, 12, 6, 
	13, 14, 14, 13, 15, 16, 14, 12, 
	12, 6, 18, 19, 19, 18, 20, 21, 
	19, 17, 17, 6, 13, 14, 14, 13, 
	22, 16, 14, 12, 12, 6, 13, 14, 
	14, 13, 22, 23, 16, 14, 12, 12, 
	6, 14, 6, 24, 6, 25, 6, 26, 
	6, 27, 6, 28, 6, 29, 6, 30, 
	31, 31, 30, 32, 33, 31, 29, 29, 
	6, 35, 36, 36, 35, 37, 38, 36, 
	34, 34, 6, 30, 31, 31, 30, 39, 
	33, 31, 29, 29, 6, 30, 31, 31, 
	30, 40, 39, 33, 31, 29, 29, 6, 
	31, 6, 41, 42, 44, 45, 44, 43, 
	44, 44, 46, 48, 47, 50, 41, 41, 
	50, 51, 52, 53, 54, 55, 49, 49, 
	42, 50, 50, 56, 57, 8, 57, 7, 
	57, 8, 57, 9, 58, 57, 41, 59, 
	0
};

static const char _xaml_trans_targs[] = {
	27, 2, 3, 4, 5, 27, 30, 6, 
	30, 7, 9, 15, 10, 10, 11, 12, 
	14, 10, 10, 11, 12, 14, 13, 30, 
	16, 17, 18, 19, 20, 21, 21, 22, 
	23, 25, 21, 21, 22, 23, 25, 24, 
	30, 30, 0, 27, 28, 29, 27, 27, 
	1, 30, 31, 32, 33, 34, 26, 35, 
	30, 30, 8, 30
};

static const char _xaml_trans_actions[] = {
	35, 11, 11, 11, 11, 52, 27, 0, 
	37, 0, 0, 0, 3, 0, 0, 3, 
	0, 61, 40, 40, 61, 40, 3, 17, 
	0, 0, 0, 0, 0, 1, 0, 0, 
	1, 0, 65, 43, 43, 65, 43, 1, 
	19, 46, 0, 29, 9, 58, 31, 33, 
	11, 49, 5, 55, 55, 55, 7, 7, 
	21, 25, 0, 23
};

static const char _xaml_to_state_actions[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 13, 0, 0, 13, 0, 
	0, 0, 0, 0
};

static const char _xaml_from_state_actions[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 15, 0, 0, 15, 0, 
	0, 0, 0, 0
};

static const unsigned char _xaml_eof_trans[] = {
	0, 1, 1, 1, 1, 1, 7, 7, 
	7, 7, 7, 7, 7, 7, 7, 7, 
	7, 7, 7, 7, 7, 7, 7, 7, 
	7, 7, 0, 0, 47, 48, 0, 57, 
	58, 58, 58, 60
};

static const int xaml_start = 27;
static const int xaml_first_final = 27;
static const int xaml_error = 0;

static const int xaml_en_xaml_line = 30;
static const int xaml_en_xaml_entity = 27;

#line 93 "ext/ohcount_native/ragel_parsers/xaml.rl"


/************************* Required for every parser *************************/

/* Parses a string buffer with XAML markup.
 *
 * @param *buffer The string to parse.
 * @param length The length of the string to parse.
 * @param count Integer flag specifying whether or not to count lines. If yes,
 *   uses the Ragel machine optimized for counting. Otherwise uses the Ragel
 *   machine optimized for returning entity positions.
 * @param *callback Callback function. If count is set, callback is called for
 *   every line of code, comment, or blank with 'lcode', 'lcomment', and
 *   'lblank' respectively. Otherwise callback is called for each entity found.
 */
void parse_xaml(char *buffer, int length, int count,
  void (*callback) (const char *lang, const char *entity, int start, int end)
  ) {
  init

  
#line 220 "ext/ohcount_native/ragel_parsers/xaml.h"
	{
	cs = xaml_start;
	ts = 0;
	te = 0;
	act = 0;
	}
#line 114 "ext/ohcount_native/ragel_parsers/xaml.rl"
  cs = (count) ? xaml_en_xaml_line : xaml_en_xaml_entity;
  
#line 230 "ext/ohcount_native/ragel_parsers/xaml.h"
	{
	int _klen;
	unsigned int _trans;
	short _widec;
	const char *_acts;
	unsigned int _nacts;
	const short *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_acts = _xaml_actions + _xaml_from_state_actions[cs];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *_acts++ ) {
	case 11:
#line 1 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{ts = p;}
	break;
#line 252 "ext/ohcount_native/ragel_parsers/xaml.h"
		}
	}

	_widec = (*p);
	_klen = _xaml_cond_lengths[cs];
	_keys = _xaml_cond_keys + (_xaml_cond_offsets[cs]*2);
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( _widec < _mid[0] )
				_upper = _mid - 2;
			else if ( _widec > _mid[1] )
				_lower = _mid + 2;
			else {
				switch ( _xaml_cond_spaces[_xaml_cond_offsets[cs] + ((_mid - _keys)>>1)] ) {
	case 0: {
		_widec = (short)(128 + ((*p) - -128));
		if ( 
#line 9 "ext/ohcount_native/ragel_parsers/xaml.rl"
 p+1 < pe && *(p+1) != '\n'  ) _widec += 256;
		break;
	}
				}
				break;
			}
		}
	}

	_keys = _xaml_trans_keys + _xaml_key_offsets[cs];
	_trans = _xaml_index_offsets[cs];

	_klen = _xaml_single_lengths[cs];
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( _widec < *_mid )
				_upper = _mid - 1;
			else if ( _widec > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _xaml_range_lengths[cs];
	if ( _klen > 0 ) {
		const short *_lower = _keys;
		const short *_mid;
		const short *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( _widec < _mid[0] )
				_upper = _mid - 2;
			else if ( _widec > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += ((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	_trans = _xaml_indicies[_trans];
_eof_trans:
	cs = _xaml_trans_targs[_trans];

	if ( _xaml_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _xaml_actions + _xaml_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 0:
#line 53 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{
  if (!line_contains_code && !line_start) line_start = ts;
  line_contains_code = 1;
}
	break;
	case 1:
#line 58 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{
  if (!line_contains_code) {
    whole_line_comment = 1;
    if (!line_start) line_start = ts;
  }
}
	break;
	case 2:
#line 31 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{
    switch(entity) {
    case XAML_SPACE:
      ls
      break;
    case XAML_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(XAML_LANG)
      break;
    case NEWLINE:
      std_newline(XAML_LANG)
      break;
    case CHECK_BLANK_ENTRY:
      check_blank_entry(XAML_LANG)
    }
  }
	break;
	case 3:
#line 52 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{ entity = INTERNAL_NL; }
	break;
	case 4:
#line 63 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{ entity = INTERNAL_NL; }
	break;
	case 5:
#line 72 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{ entity = XAML_SPACE; }
	break;
	case 6:
#line 75 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{ entity = NEWLINE;   }
	break;
	case 7:
#line 76 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{ entity = XAML_ANY;   }
	break;
	case 8:
#line 88 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{ entity = XAML_SPACE;   }
	break;
	case 9:
#line 89 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{ entity = XAML_COMMENT; }
	break;
	case 12:
#line 1 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p+1;}
	break;
	case 13:
#line 73 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p+1;}
	break;
	case 14:
#line 74 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p+1;}
	break;
	case 15:
#line 31 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p+1;{
    switch(entity) {
    case XAML_SPACE:
      ls
      break;
    case XAML_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(XAML_LANG)
      break;
    case NEWLINE:
      std_newline(XAML_LANG)
      break;
    case CHECK_BLANK_ENTRY:
      check_blank_entry(XAML_LANG)
    }
  }}
	break;
	case 16:
#line 31 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p+1;{
    switch(entity) {
    case XAML_SPACE:
      ls
      break;
    case XAML_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(XAML_LANG)
      break;
    case NEWLINE:
      std_newline(XAML_LANG)
      break;
    case CHECK_BLANK_ENTRY:
      check_blank_entry(XAML_LANG)
    }
  }}
	break;
	case 17:
#line 31 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p;p--;{
    switch(entity) {
    case XAML_SPACE:
      ls
      break;
    case XAML_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(XAML_LANG)
      break;
    case NEWLINE:
      std_newline(XAML_LANG)
      break;
    case CHECK_BLANK_ENTRY:
      check_blank_entry(XAML_LANG)
    }
  }}
	break;
	case 18:
#line 31 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p;p--;{
    switch(entity) {
    case XAML_SPACE:
      ls
      break;
    case XAML_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(XAML_LANG)
      break;
    case NEWLINE:
      std_newline(XAML_LANG)
      break;
    case CHECK_BLANK_ENTRY:
      check_blank_entry(XAML_LANG)
    }
  }}
	break;
	case 19:
#line 31 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p;p--;{
    switch(entity) {
    case XAML_SPACE:
      ls
      break;
    case XAML_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(XAML_LANG)
      break;
    case NEWLINE:
      std_newline(XAML_LANG)
      break;
    case CHECK_BLANK_ENTRY:
      check_blank_entry(XAML_LANG)
    }
  }}
	break;
	case 20:
#line 31 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{{p = ((te))-1;}{
    switch(entity) {
    case XAML_SPACE:
      ls
      break;
    case XAML_ANY:
      code
      break;
    case INTERNAL_NL:
      std_internal_newline(XAML_LANG)
      break;
    case NEWLINE:
      std_newline(XAML_LANG)
      break;
    case CHECK_BLANK_ENTRY:
      check_blank_entry(XAML_LANG)
    }
  }}
	break;
	case 21:
#line 81 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p+1;{
    callback(XAML_LANG, xaml_entities[entity], cint(ts), cint(te));
  }}
	break;
	case 22:
#line 91 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p+1;}
	break;
	case 23:
#line 81 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p;p--;{
    callback(XAML_LANG, xaml_entities[entity], cint(ts), cint(te));
  }}
	break;
	case 24:
#line 91 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{te = p;p--;}
	break;
	case 25:
#line 91 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{{p = ((te))-1;}}
	break;
#line 576 "ext/ohcount_native/ragel_parsers/xaml.h"
		}
	}

_again:
	_acts = _xaml_actions + _xaml_to_state_actions[cs];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *_acts++ ) {
	case 10:
#line 1 "ext/ohcount_native/ragel_parsers/xaml.rl"
	{ts = 0;}
	break;
#line 589 "ext/ohcount_native/ragel_parsers/xaml.h"
		}
	}

	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	if ( p == eof )
	{
	if ( _xaml_eof_trans[cs] > 0 ) {
		_trans = _xaml_eof_trans[cs] - 1;
		goto _eof_trans;
	}
	}

	_out: {}
	}
#line 116 "ext/ohcount_native/ragel_parsers/xaml.rl"

  // if no newline at EOF; callback contents of last line
  if (count) { process_last_line(XAML_LANG) }
}

#endif

/*****************************************************************************/
